#ifndef __ARC_SRM_REQUEST_H__
#define __ARC_SRM_REQUEST_H__

#include <string>
#include <list>

#include "../se/files.h"
#include "srm1_soapH.h"
#include "../../misc/thread.h"

class SRMRequests;

class SRMRequest {
 friend class SRMRequests;
 protected:
  std::list<SEFiles::iterator> files_;
  std::string state_;
  int id_;
  std::string userid_;
  time_t created_;
  LockSimple lock_;
 public:
  SRMRequest(int id,const char* userid);
  virtual ~SRMRequest(void);
  virtual void add(SEFiles::iterator& file);
  virtual bool active(void);
  virtual const char* type(void);
  virtual SRMv1Type__RequestStatus* get(struct soap* sp,const char* service_url);
  void acquire(void) { lock_.block(); };
  void release(void) { lock_.unblock(); };
  int id(void) { return id_; };
  SEFile* file(int fileid);
};

class SRMRequests {
 private:
  std::list<SRMRequest*> reqs_;
  LockSimple lock_;
 public:
  SRMRequests(void);
  ~SRMRequests(void);
  void add(SRMRequest* req);
  SRMRequest* acquire(int id,const char* userid);
  //bool release(int id);
  bool remove(int id);
  bool maintain(int id);
  bool maintain(void);
};

class SRMRequests_Thread: public Thread {
 private:
  SRMRequests& reqs_;
  virtual void func(void);
 public:
  SRMRequests_Thread(SRMRequests& r):reqs_(r) { attention(); };
  ~SRMRequests_Thread(void) { };
};

#endif // __ARC_SRM_REQUEST_H__
